<html>

<head lang="es">
  <meta charset="utf-8" />
  <title>Trabajo en grupo TG2</title>
  <link rel="stylesheet" href="style.css" />
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css"
    integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous" />
  <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js"
    integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n"
    crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
    integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
    crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"
    integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6"
    crossorigin="anonymous"></script>
</head>

<body>
  <div class="top-text">
    <div class="card top-card">
      <div class="card-body">
        <p class="work-title">Desarrollo con Tecnologias Emergentes</p>
        <p class="work-subtitle">Curso 2019/2020</p>
        <hr />
        <p style="font-size: 2rem; font-weight: 200;">Grupo T6</p>
        <hr />
        <p style="font-size: 2rem; font-weight: 200;" class="work-title">
          TG2 - Evaluar y comparar dos tecnologias emergentes
        </p>
      </div>
    </div>
  </div>
  <div class="container content">
    <h1>Índice</h1>
    <ul class="index list-group">
      <a class="list-group-item list-group-item-action" href="#1">1. Información general</a>
      <a class="list-group-item list-group-item-action" href="#2">2. Descripción de las tecnologías</a>
      <a class="list-group-item list-group-item-action" href="#3">3. Criterios de comparación</a>
      <a class="list-group-item list-group-item-action" href="#4">4. Evaluación de los criterios por categoría</a>
      <a class="list-group-item list-group-item-action" href="#5">5. Comparación de las tecnologías</a>
      <a class="list-group-item list-group-item-action" href="#6">6. Recomendaciones</a>
    </ul>
  </div>
  <br>
  <br>
  <div class="container-fluid not-even-container" style="padding-bottom: 40px;">
    <div class="row justify-content-center">
      <div class="col-sm-12 text-center">
        <h1 id="1" class="section-title">1. Información general</h1>
        <br />
        <br />
      </div>
    </div>
    <div class="row justify-content-center">
      <div class="col-sm-4">
        <h2>1.1 Autores</h2>
        <ul>
          <li>Cristobal Placencia - Product Owner</li>
          <li>Daniel Molina</li>
          <li>Carlos Gamero</li>
          <li>Adrián Sanz</li>
          <li>Daniel Villalobos</li>
        </ul>
      </div>
      <div class="col-sm-4">
        <h2>1.2 Proyecto Scrum y repositorio de GitLab</h2>
        <p>
          Se crea un proyecto en gitlab <a href="https://gitlab.com/dte2020/t6/tg2" style="color: #fafafa !important;"><span style="color: wihte !important; font-weight: bold;">Accesible en este enlace</span></a>
          <br />
          <a data-toggle="modal" data-target="#boardModal" style="cursor: pointer;"><img height="256" width="512" src="./assets/boards.png"
              class="rounded"></a>
          <p>Hacer click para abrir más grande</p>
          <div id="boardModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
            aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered">
              <div class="modal-content">
                <img height="512px" width="1024px" src="./assets/boards.png" class="img-responsive">
              </div>
            </div>
          </div>
        </p>
      </div>
    </div>
    <div class="row justify-content-center">
      <div class="col-sm-4">
        <h2>1.3 Burndown Chart</h2>
        <a data-toggle="modal" data-target="#burnModal" style="cursor: pointer;"><img height="256" width="512" src="./assets/burndown.png"
          class="rounded"></a>
      <p>Hacer click para abrir más grande</p>
      <div id="burnModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
          <div class="modal-content">
            <img height="512px" width="1024px" src="./assets/burndown.png" class="img-responsive">
          </div>
        </div>
      </div>
      </div>
      <div class="col-sm-4">
        <h2>1.4 Presentación del trabajo</h2>
        <p>
          En este apartado se debe incluir el enlace al archivo de la
          presentacion con diapositivas, ubicado en el repositorio del
          proyecto.
        </p>
        <button type="button" class="btn" style="background-color: #ef6c00;">
          <a href="./assets/presentacion.pptx" style="color: white; text-decoration: none;">
            Enlace a la presentación
          </a>
        </button>
      </div>
    </div>
  </div>
  <div class="container-fluid even-container">
    <div class="row justify-content-center">
      <div class="col-sm-12 text-center">
        <h1 id="2" class="section-title">2. Descripción de las tecnologías</h1>

        <br />
        <br />
      </div>
    </div>
    <div class="row justify-content-center">
      <div class="col-sm-4">
        <h2>2.1 Descripción tecnología 1 (Kotlin)</h2>
        <p>
          Kotlin es un lenguaje de programación de tipado estático que aunque
          no tiene una sintaxis compatible con Java, corre sobre la máquina
          virtual de Java y que también puede ser compilado a código fuente de
          JavaScript. Kotlin está diseñado para interoperar con código Java y
          es dependiente del código Java de su biblioteca de clases, tal como
          pueda ser el entorno de colecciones de Java (Java collections
          framework).
          <br />
          Además de clases y métodos (en Kotlin se llaman funciones miembro)
          clásicos de la programación orientada a objetos, Kotlin también
          soporta programación por procedimientos y el uso de funciones. Igual
          que en C y C++, el punto de entrada a un programa Kotlin es una
          función llamada "main", que recibe un array que contiene los
          argumentos pasados desde la línea de comandos. Soporta la
          interpolación de variables dentro de cadenas de texto al estilo de
          los shell scripts de Perl y Unix/Linux. La inferencia de tipos es
          otra de las características de Kotlin. Kotlin hace una distinción
          entre tipos nullables y no-nullables (aquellos que pueden o no tener
          un valor nulo).
          <br />
          Todos los objetos nullables tienen que ser declarados con un "?"
          sufijo después del nombre de tipo. Las operaciones con objetos
          nullables necesitan cuidado especial de los desarrolladores: una
          verificación de valor null debe ser realizado antes de utilizar el
          valor.
        </p>
      </div>
      <div class="col-sm-4">
        <h2>2.2 Descripción tecnología 2 (Scala)</h2>
        <p>
          Scala es un lenguaje de programación multi-paradigma diseñado para
          expresar patrones comunes de programación en forma concisa, elegante
          y con tipos seguros. Integra sutilmente características de lenguajes
          funcionales y orientados a objetos. La implementación actual se
          ejecuta en la máquina virtual de Java y es compatible con las
          aplicaciones Java existentes.
          <br />
          Scala es un lenguaje de programación puro orientado a objetos, en el
          sentido de que cada valor es un objeto. El tipo y comportamiento de
          los objetos se describe por medio de clases y traits. La abstracción
          de clases se realiza extendiendo otras clases y usando un mecanismo
          de composición basado en mixins como un reemplazo limpio de la
          herencia múltiple. También posee características propias de los
          lenguajes funcionales. En Scala las funciones son valores de primera
          clase, soportando funciones anónimas, orden superior, funciones
          anidadas y currificación. Scala viene integrado de fábrica con la
          técnica de pattern matching para modelar tipos algebraicos usados en
          muchos lenguajes funcionales.
          <br />
          Scala está equipado con un sistema de tipos expresivo que refuerza a
          que las abstracciones de tipos se usen en forma coherente y segura.
          Scala se diseñó teniendo en mente el hecho de que en la práctica el
          desarrollo de aplicaciones requiere a menudo de extensiones
          específicas del lenguaje. Para ello, Scala proporciona una
          combinación única de mecanismos que hacen fácil y sin problemas
          agregar construcciones nuevas al lenguaje en forma de bibliotecas.
        </p>
      </div>
    </div>
  </div>
  <div class="container-fluid not-even-container">
    <div class="row justify-content-center">
      <div class="col-sm-12 text-center">
        <h1 id="3" class="section-title">3. Criterios de comparación</h1>
      </div>
    </div>
    <br />
    <div class="row justify-content-center">
      <div class="col-sm-10 justify-content-center">
        <div class="row justify-content-center">
          <h2>3.1 Categoría A: General</h2>
        </div>
        <br>
        <br>
        <div class="row justify-content-center">

          <div class="criterio col-sm-5">
            <h3>3.1.1 Criterio A.1: Licencia</h3>
            <ul>
              <li>Nombre del criterio: Licencia.</li>
              <li>Descripción: Tipo de licencia necesaria.</li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.1.2 Criterio A.2: Versiones</h3>
            <ul>
              <li>Nombre del criterio: Versiones.</li>
              <li>Descripción: Disponibilidad de distintas versiones.</li>
              <li>Tipo de valor: Boolean (SI/NO).</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.1.3 Criterio A.3: Autor de la herramienta</h3>
            <ul>
              <li>Nombre del criterio: Autor.</li>
              <li>
                Descripción: Nombre de la persona, institución o empresa que ha
                creado la herramienta.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.1.4 Criterio A.4: Comunidad</h3>
            <ul>
              <li>Nombre del criterio: Comunidad.</li>
              <li>
                Descripción: Comunidad de ingenieros que se ayudan entre ellos
                para mejorar en sus conocimientos sobre la herramienta.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.1.5 Criterio A.5: Documentación técnica oficial</h3>
            <ul>
              <li>Nombre del criterio: Documentación.</li>
              <li>
                Descripción: Calidad de la información aportada por el documento
                oficial de la tecnología.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.1.6 Criterio A.6: Competitividad</h3>
            <ul>
              <li>Nombre del criterio: Competitividad.</li>
              <li>
                Descripción: Indicar la posición en el sector de cada herramienta
                según el número de descargas, para obtener una visión objetiva de
                su competitividad.
              </li>
              <li>Tipo de valor: Numeric.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.1.7 Criterio A.7: Influencia</h3>
            <ul>
              <li>Nombre del criterio: Influencia.</li>
              <li>
                Descripción: Por que otro lenguajes ha sido influenciada la
                herramienta.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>
        </div>

        <br>
        <hr>
        <br>
        <div class="row justify-content-center">
          <h2>3.2 Categoría B: Implementación y desarrollo</h2>
        </div>
        <br>
        <br>

        <div class="row justify-content-center">
          <div class="criterio col-sm-5">
            <h3>3.2.1 Criterio B.1: Extensión del código</h3>
            <ul>
              <li>Nombre del criterio: Extensión.</li>
              <li>
                Descripción: Indica la extensión de código para el mismo programa
                en cada herramienta.
              </li>
              <li>Tipo de valor: Numeric.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.2.2 Criterio B.2: Tiempo de ejecución</h3>
            <ul>
              <li>Nombre del criterio: Tiempo de ejecución.</li>
              <li>
                Descripción: Indicar el tiempo de ejecución en milisegundos para
                el mismo programa.
              </li>
              <li>Tipo de valor: Numeric.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.2.3 Criterio B.3: Versión JVM</h3>
            <ul>
              <li>Nombre del criterio: Versión.</li>
              <li>
                Descripción: Indicar cuales son las versiones disponibles de
                ejecución de la JVM.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.2.4 Criterio B.4: Nivel de estrés</h3>
            <ul>
              <li>Nombre del criterio: Nivel de estrés.</li>
              <li>
                Descripción: Se somete al sistema a condiciones extremas y muestra
                el nivel de estrés que soporta el software.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.2.5 Criterio B.5: Curva de aprendizaje</h3>
            <ul>
              <li>Nombre del criterio: Curva de aprendizaje.</li>
              <li>
                Descripción: Cantidad de horas necesarias para poder comenzar a
                implementar programas funcionales en la tecnología.
              </li>
              <li>Tipo de valor: Numeric.</li>
            </ul>
          </div>
        </div>

        <br>
        <hr>
        <br>
        <div class="row justify-content-center">
          <h2>3.3 Categoría C: Calidad software</h2>
        </div>
        <br>
        <br>
        <div class="row justify-content-center">
          <div class="criterio col-sm-5">
            <h3>3.3.1 Criterio C.1: Tiempo de vida</h3>
            <ul>
              <li>Nombre del criterio: Tiempo de vida.</li>
              <li>
                Descripción: Madurez del lenguaje. Tiempo que lleva
                desarrollándose.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.3.2 Criterio C.2: Control de errores</h3>
            <ul>
              <li>Nombre del criterio: Control de errores.</li>
              <li>
                Descripción: Capacidad del manejo de excepciones en la tecnología.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.3.3 Criterio C.3: Test de caja negra</h3>
            <ul>
              <li>Nombre del criterio: Test de caja negra.</li>
              <li>
                Descripción: Capacidad de poder realizar el test de caja negra con
                la tecnología.
              </li>
              <li>Tipo de valor: Boolean (SI/NO).</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.3.4 Criterio C.4: Test de caja blanca</h3>
            <ul>
              <li>Nombre del criterio: Test de caja blanca.</li>
              <li>
                Descripción: Capacidad de poder realizar el test de caja blanca
                con la tecnología.
              </li>
              <li>Tipo de valor: Boolean (SI/NO).</li>
            </ul>
          </div>
        </div>

        <br>
        <hr>
        <br>
        <div class="row justify-content-center">
          <h2>3.4 Categoría D: Soporte.</h2>
        </div>
        <br>
        <br>
        <div class="row justify-content-center">
          <div class="criterio col-sm-5">
            <h3>3.4.1 Criterio D.1: Soporte técnico</h3>
            <ul>
              <li>Nombre del criterio: Soporte técnico.</li>
              <li>
                Descripción: Ayudas y soporte técnico disponible para uso de la
                herramienta o para la consulta sobre errores.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.4.2 Criterio D.2: FAQ</h3>
            <ul>
              <li>Nombre del criterio: FAQ.</li>
              <li>
                Descripción: Página oficial con preguntas y respuestas de la
                herramienta.
              </li>
              <li>Tipo de valor: Boolean (SI/NO).</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.4.3 Criterio D.3: Soporte y mantenimiento</h3>
            <ul>
              <li>Nombre del criterio: Soporte y mantenimiento.</li>
              <li>
                Descripción: Se valora la calidad del soporte y mantenimiento que
                se realiza a la herramienta.
              </li>
              <li>Tipo de valor: Texto libre.</li>
            </ul>
          </div>

          <div class="criterio col-sm-5">
            <h3>3.4.4 Criterio D.4: Demostraciones</h3>
            <ul>
              <li>Nombre del criterio: Demostraciones.</li>
              <li>
                Descripción: Indicar si la herramienta incluye demostraciones del
                uso de la tecnología.
              </li>
              <li>Tipo de valor: Boolean (SI/NO).</li>
            </ul>
          </div>
        </div>
        <br />
        <br />
      </div>
    </div>
  </div>

  </div>
  </div>
  <div class="container-fluid even-container">
    <div class="row justify-content-center">
      <div class="col-sm-12 text-center">
        <h1 id="4" class="section-title">4. Evaluacion de los criterios por categoria</h1>
        <br />
        <br />
      </div>
    </div>
    <div class="row justify-content-center">
      <h2>4.1 Tecnología 1: Kotlin</h2>
    </div>
    <br>

    <div class="row justify-content-center">
      <div class="col-sm-10 justify-content-center">
        <table class="table table-light table-striped">
          <thead>
            <tr>
              <th class="align-middle text-center text-justify" scope="col">Criterio</th>
              <th class="align-middle text-center text-justify" scope="col">Tecnología 1: Kotlin</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th>Criterio A.1: Licencia</th>
              <td class="align-middle text-center text-justify">Licencia Apache Versión 2.0</td>
            </tr>
            <tr>
              <th>Criterio A.2: Versiones</th>
              <td class="align-middle text-center text-justify">Si</td>
            </tr>
            <tr>
              <th>Nota A.2: Versiones</th>
              <td class="align-middle text-center text-justify">Kotlin actualmente dispone de numerosas versiones,
                siendo la versión 1.3.61, la más reciente.</td>
            </tr>
            <tr>
              <th>Criterio A.3: Autor de la herramienta</th>
              <td class="align-middle text-center text-justify">La empresa que creó Kotlin es JetBrains.</td>
            </tr>
            <tr>
              <th>Criterio A.4: Comunidad</th>
              <td class="align-middle text-center text-justify">
                <p>
                  Actualmente hay muchas comunidades que tratan Kotlin, sin
                  embargo, la comunidad en español que lo trata de manera más
                  profesional y nos informan acerca de las últimas novedades del
                  lenguaje es la siguiente:
                  <a href="https://kotlin.es/" target="_blank">Web oficial de Kotlin</a>.
                  <br>
                  <br>
                  Esta comunidad está formada por desarrolladores web e
                  ingenieros entre otros.
                </p>
              </td>
            </tr>
            <tr>
              <th>Criterio A.5: Documentación técnica oficial</th>
              <td class="align-middle text-center text-justify">
                La documentación es bastante extensa ya que abarca desde las
                características del lenguaje hasta su propia sintaxis, pero
                hay que decir a su favor que es muy completa. La podemos
                encontrar en el siguiente enlace:
                <a href="https://kotlinlang.org/docs/kotlin-docs.pdf" target="_blank">Documentación oficial de
                  Kotlin</a>.
              </td>
            </tr>
            <tr>
              <th>Criterio A.6: Competitividad</th>
              <td class="align-middle text-center text-justify">30</td>
            </tr>
            <tr>
              <th>Nota A.6: Competitividad</td>
              <td class="align-middle text-center text-justify">
                A pesar de haber diferentes rankings, hemos tomado como referencia el siguiente:
                <a href="https://www.tiobe.com/tiobe-index/">Índice Tiobe</a>.
                <br>
                Actualmente, Kotlin no está en las posiciones más altas del sector ya que es un lenguaje bastante
                reciente, sin embargo está cogiendo cada vez más tendencia de uso debido entre otras cosas a su
                compatibilidad con Android y estará en las posiciones más altas dentro de muy poco tiempo.
              </td>
            </tr>
            <tr>
              <th>Criterio A.7: Influencia</th>
              <td class="align-middle text-center text-justify">
                Los lenguajes de programación por los que ha sido influenciado
                Kotlin son C#, Eiffel, Gosu, Groovy, Java, ML, Python, Scala y
                Swift
              </td>
            </tr>
            <tr>
              <th>Criterio B.1: Extensión del código</th>
              <td class="align-middle text-center text-justify">2</td>
            </tr>
            <tr>
              <th>Criterio B.2: Tiempo de ejecución</th>
              <td class="align-middle text-center text-justify">160</td>
            </tr>
            <tr>
              <th>Nota B.1 y B.2: Extensión del código y Tiempo de ejecución</th>
              <td class="align-middle text-center text-justify">En estos dos criterios, el programa se encarga de crear
                una lista de enteros y añadir un millón de
                numeros, del 1 al millón. El tiempo que tarda en ejecutar el programa es de 160 milisegundos.</td>

            </tr>
            <tr>
              <th>Imagen B.1 y B.2: Extensión del código y Tiempo de ejecución</th>
              <td class="align-middle text-center text-justify">
                <img src="./assets/funcion-kotlin.jpeg" alt="FUNCIÓN KOTLIN" />
              </td>
            </tr>
            <tr>
              <th>Criterio B.3: Versión JVM.</th>
              <td class="align-middle text-center text-justify">De la versión 8 a la 13</td>
            </tr>
            <tr>
              <th>Criterio B.4: Nivel de estrés</th>
              <td class="align-middle text-center text-justify">
                El nivel de estrés no es muy alto, a no ser que se realicen
                programas, los cuales requieran un uso muy elevado de memoria,
                lo que implica un nivel alto de carga de trabajo.
              </td>
            </tr>
            <tr>
              <th>Criterio B.5: Curva de aprendizaje</th>
              <td class="align-middle text-center text-justify">30</td>
            </tr>
            <tr>
              <th>Nota B.5: Curva de aprendizaje</th>
              <td class="align-middle text-center text-justify">
                La curva de aprendizaje depende del nivel de programación que tengas. En este caso suponemos que el
                programador domina Java, y al ser un lenguaje bastante parecido en cuando a sintaxis, se aprende
                bastante rápido
              </td>
            </tr>
            <tr>
              <th>Criterio C.1: Tiempo de vida</th>
              <td class="align-middle text-center text-justify">
                Este lenguaje lleva desarrollándose desde 2011; es decir 9
                años.
              </td>
            </tr>
            <tr>
              <th>Criterio C.2: Control de errores</th>
              <td class="align-middle text-center text-justify">
                En Kotlin a diferencia de otros lenguajes, Kotlin no tiene
                excepciones previamente definidas como puede ser en Java.
              </td>
            </tr>
            <tr>
              <th>Criterio C.3: Test de caja negra</th>
              <td class="align-middle text-center text-justify">SI</td>
            </tr>
            <tr>
              <th>Criterio C.4: Test de caja blanca</th>
              <td class="align-middle text-center text-justify">SI</td>
            </tr>
            <tr>
              <th>Criterio D.1: Soporte técnico</th>
              <td class="align-middle text-center text-justify">
                Kotlin dispone de una web con soporte técnico en la cual
                puedes consultar cualquier cosa acerca con un experto en dicho
                lenguaje. Su link es el siguiente:
                <a href="https://www.kotlindevelopment.com/kotlin-support/" target="_blank">Kotlin support</a>.
              </td>
            </tr>
            <tr>
              <th>Criterio D.2: FAQ</th>
              <td class="align-middle text-center text-justify">SI</td>
            </tr>
            <tr>
              <th>Nota D.2: FAQ</th>
              <td class="align-middle text-center text-justify">
                El FAQ se encuentra en el siguiente link:
                <a href="https://kotlinlang.org/docs/reference/faq.html">
                  FAQ Kotlin
                </a>
              </td>
            </tr>
            <tr>
              <th>Criterio D.3: Soporte y mantemiento</th>
              <td class="align-middle text-center text-justify">
                Kotlin dispone de soporte y mantenimiento cada cierto tiempo,
                el cual es llevado a cabo por sus desarrolladores
              </td>
            </tr>
            <tr>
              <th>Criterio D.4: Demostraciones</th>
              <td class="align-middle text-center text-justify">SI</td>
            </tr>
            <tr>
              <th>Nota D.4: Demostraciones</th>
              <td class="align-middle text-center text-justify"></td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <br>
    <br>
    <div class="row justify-content-center">
      <h2>4.1 Tecnología 2: Scala</h2>
    </div>
    <br>

    <div class="row justify-content-center">
      <div class="col-sm-10 justify-content-center">
        <table class="table table-light table-striped">
          <thead>
            <tr>
              <th class="align-middle text-center text-justify" scope="col">Criterio</th>
              <th class="align-middle text-center text-justify" scope="col">Tecnología 2: Scala</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <th>Criterio A.1: Licencia</th>
              <td class="align-middle text-center text-justify">Licencia Apache Versión 2.0</td>
            </tr>
            <tr>
              <th>Criterio A.2: Versiones</th>
              <td class="align-middle text-center text-justify">Si</td>
            </tr>
            <tr>
              <th>Nota A.2: Versiones</th>
              <td class="align-middle text-center text-justify">Scala dispone de varias versiones en las cuales la más
                reciente es la versión 2.12 </td>
            </tr>
            <tr>
              <th>Criterio A.3: Autor de la herramienta</th>
              <td class="align-middle text-center text-justify">
                El creador de este lenguaje de programación es Martin Odersky,
                un informático alemán y profesor de métodos de programación en
                la Universidad Politécnica Federal de Lausanne, en Suiza.
              </td>
            </tr>
            <tr>
              <th>Criterio A.4: Comunidad</th>
              <td class="align-middle text-center text-justify">
                Existen varios foros y comunidades de habla hispana en los que
                se ayudan mutuamente para completar proyectos propios en este
                lenguaje, ya que la información para extraer y aprender es muy
                extensa. No existe una comunidad principal.
              </td>
            </tr>
            <tr>
              <th>Nota A.4: Comunidad</th>
              <td class="align-middle text-center text-justify">
                En la página web oficial de Scala existe un foro en el que los usuarios preguntan dudas sobre la
                aplicación y un trabajador oficial le responde en cierto tiempo. Aún así, los usuarios prefieren usar
                otros sitios web o foros distintos para preguntar puntos más concretos al programar una aplicación.
              </td>
            </tr>
            <tr>
              <th>Criterio A.5: Documentación técnica oficial</th>
              <td class="align-middle text-center text-justify">
                La documentación técnica de scala es extensa. De este modo, en
                su página oficial se puede buscar la información que se quiera
                encontrar desde el siguiente buscador:
                <a href="https://www.scala-lang.org/api/current/?_ga=1.241039811.1310790544.1468501313"
                  target="_blank">Documentación oficial de Scala</a>
              </td>
            </tr>
            <tr>
              <th>Criterio A.6: Competitividad</th>
              <td class="align-middle text-center text-justify">28</td>
            </tr>
            <tr>
              <th>Nota A.6: Competitividad</th>
              <td class="align-middle text-center text-justify">
                Scala, actualmente, no es un lenguaje de programación comúnmente usado como Java o C#. Hemos
                utilizado el siguiente ranking para obtener dicha información:
                <a href="https://www.tiobe.com/tiobe-index/">Índice Tiobe</a>.
              </td>
            </tr>
            <tr>
              <th>Criterio A.7: Influencia</th>
              <td class="align-middle text-center text-justify">
                Los principales lenguajes de programación por los que Scala ha
                sido influenciado son: C++, C#, Java
              </td>
            </tr>
            <tr>
              <th>Criterio B.1: Extensión del código</th>
              <td class="align-middle text-center text-justify">2</td>
            </tr>
            <tr>
              <th>Criterio B.2: Tiempo de ejecución</th>
              <td class="align-middle text-center text-justify">620</td>
            </tr>
            <tr>
              <th>Nota B.1 y B.2: Extensión del código y Tiempo de ejecución</th>
              <td class="align-middle text-center text-justify">El programa a comparar es una función se ejecuta en la
                página paiza.io (al igual que para el programa
                en Kotlin) y rellena una lista de enteros desde 1 a un millón. En este caso, el programa se ejecuta en
                0,62 segundos, 620 ms</td>
            </tr>
            <tr>
              <th>Imagen B.1 y B.2: Extensión del código y Tiempo de ejecución</th>
              <td class="align-middle text-center text-justify">
                <img src="./assets/funcion-scala.jpeg" alt="FUNCIÓN SCALA" />
              </td>
            </tr>
            <tr>
              <th>Criterio B.3: Versión JVM.</th>
              <td class="align-middle text-center text-justify">De la versión 6 a la 14</td>
            </tr>
            <tr>
              <th>Criterio B.4: Nivel de estrés</th>
              <td class="align-middle text-center text-justify">
                El nivel de estrés en Scala no es muy alto a no ser que se
                realicen algunas operaciones al realizar programas que
                requieran un gran uso de memoria.
              </td>
            </tr>
            <tr>
              <th>Criterio B.5: Curva de aprendizaje</th>
              <td class="align-middle text-center text-justify">65</td>
            </tr>
            <tr>
              <th>Nota B.5: Curva de aprendizaje</th>
              <td class="align-middle text-center text-justify">
                La curva de aprendizaje depende del nivel del usuario. Las horas anteriormente escritas en este
                criterio se refieren a las horas de introducción que un programador experimentado en Java necesita para
                manejar de forma suficiente Scala.
              </td>
            </tr>
            <tr>
              <th>Criterio C.1: Tiempo de vida</th>
              <td class="align-middle text-center text-justify">
                Scala se desarrolló en el año 2001, por lo que el tiempo de vida de este lenguaje es de 19 años
              </td>
            </tr>
            <tr>
              <th>Criterio C.2: Control de errores</th>
              <td class="align-middle text-center text-justify">
                En Scala, las excepciones son definidas en el código. En el siguiente enlace se puede se pueden
                comprobar los diferentes errores:
                <a href="https://riptutorial.com/es/scala/topic/910/manejo-de-errores.">
                  Manejo de errores en Scala
                </a>
              </td>
            </tr>
            <tr>
              <th>Criterio C.3: Test de caja negra</th>
              <td class="align-middle text-center text-justify">SI</td>
            </tr>
            <tr>
              <th>Criterio C.4: Test de caja blanca</th>
              <td class="align-middle text-center text-justify">SI</td>
            </tr>
            <tr>
              <th>Criterio D.1: Soporte técnico</th>
              <td class="align-middle text-center text-justify">
                Scala dispone de un soporte técnico en español para países de Latinoamérica y España. El enlace es la
                siguiente:
                <a href="https://scala.com/es/support-technical/">
                  Soporte técnico español Scala
                </a>
              </td>
            </tr>
            <tr>
              <th>Criterio D.2: FAQ</th>
              <td class="align-middle text-center text-justify">SI</td>
            </tr>
            <tr>
              <th>Nota D.2: FAQ</th>
              <td class="align-middle text-center text-justify">
                En la página oficial de Scala existe un apartado en el que el usuario puede preguntar dudas o problemas
                que le han surgido al utilizar la aplicación. El enlace es el siguiente:
                <a href="https://scala.com/es/connect/support/">
                  FAQ Scala
                </a>
              </td>
            </tr>
            <tr>
              <th>Criterio D.3: Soporte y mantemiento</th>
              <td class="align-middle text-center text-justify">
                Scala dispone de soporte y mantenimiento sin coste adicional para todos los Asociados Certificados de
                Scala y para los clientes de Scala.
                El enlace es el siguiente:
                <a href="https://scala.com/es/support-technical/">
                  Technical Support Scala
                </a>
              </td>
            </tr>
            <tr>
              <th>Criterio D.4: Demostraciones</th>
              <td class="align-middle text-center text-justify">SI</td>
            </tr>
            <tr>
              <th>Nota D.4: Demostraciones</th>
              <td class="align-middle text-center text-justify">
                Los tutoriales más eficaces son los que son enseñados mediante video debido a que el programador
                entiende mejor los conceptos del lenguaje.
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <br>
    <br>
  </div>
  <div class="container-fluid not-even-container">
    <div class="row justify-content-center">
      <div class="col-sm-12 text-center">
        <h1 id="5" class="section-title">5. Comparación de las tecnologías</h1>
        <p class="explication">
          Debe incluir al menos una tabla resumen cruzando los criterios y los
          valores de cada tecnología. Con una columna de comentarios sobre la
          comparacion. Esta tabla es obligatoria, aunque se pueden incluir
          otros graficos o tablas complementarias copiadas y pegadas desde
          diversas fuentes de informacion, siempre que debajo de cada uno se
          indique la fuente (al menos la URL).
        </p>
        <br />
        <br />
        <div class="row justify-content-center">
          <div class="col-sm-10 justify-content-center table-responsive">
            <table class="table table-light table-striped align-middle">
              <thead>
                <tr>
                  <th class="align-middle text-center text-justify" scope="col">Criterio</th>
                  <th class="align-middle text-center text-justify" scope="col">Tecnología 1: Kotlin</th>
                  <th class="align-middle text-center text-justify" scope="col">Tecnología 2: Scala</th>
                  <th class="align-middle text-center text-justify" scope="col">Comentarios</th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio A1: Licencia</td>
                  <td class="align-middle text-center text-justify">Licencia Apache Versión 2.0</td>
                  <td class="align-middle text-center text-justify">Licencia Apache Versión 2.0</td>
                  <td class="align-middle text-center text-justify">
                    La Licencia Apache permite al usuario del software la
                    libertad de usarlo para cualquier propósito, distribuirlo,
                    modificarlo, y distribuir versiones modificadas de ese
                    software.
                    <br>
                    <br>
                    Requiere la conservación del aviso de derecho de autor y el descargo de responsabilidad, pero no
                    es una licencia copyleft, ya que no requiere la redistribución del código fuente cuando se
                    distribuyen versiones modificadas.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio A2: Versiones</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">
                    Kotlin tiene un total de 29 versiones, a diferencia de las
                    9 de Scala. Destacar que también hay una comunidad mayor
                    ayudando a la mejora de Kotlin
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio A3: Autor de la herramienta</td>
                  <td class="align-middle text-center text-justify">JetBrains</td>
                  <td class="align-middle text-center text-justify">Martin Odersky</td>
                  <td class="align-middle text-center text-justify">
                    A diferencia de Kotlin, la cual fue y es un proyecto de
                    JetBrains, Scala fue desarrollada en un principio por el
                    profesor Martin Odersky, con la finalidad de demostrar que
                    una fusión de dos paradigmas, Funcional y Orientado a
                    Objetos, era posible y tiene aplicaciones prácticas.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio A4: Comunidad</td>
                  <td class="align-middle text-center text-justify">
                    Actualmente hay muchas comunidades que tratan Kotlin, sin
                    embargo, la comunidad en español que lo trata de manera
                    más profesional y nos informan acerca de las últimas
                    novedades del lenguaje es la siguiente:
                    https://kotlin.es/. Esta comunidad está formada por
                    desarrolladores web e ingenieros entre otros.
                  </td>
                  <td class="align-middle text-center text-justify">
                    Existen varios foros y comunidades de habla hispana en los
                    que se ayudan mutuamente para completar proyectos propios
                    en este lenguaje, ya que la información para extraer y
                    aprender es muy extensa. No existe una comunidad
                    principal.
                  </td>
                  <td class="align-middle text-center text-justify">
                    Debido a la mayor sencillez y comprensión de código de
                    Kotlin sobre Scala y la popularidad de JetBrains, además
                    de ser un lenguaje con un propósito muy concreto, Kotlin
                    tiene una comunidad mucho mejor establecida que Scala,
                    implicando este último un conociemiento y destrezas
                    mayores. También, en Kotlin hay más gente iniciándose y
                    los usuarios de Scala suelen ser desarrolladores más
                    especializados, los cuales se apoyan y comprenden mejor la
                    documentación.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio A5: Documentación técnica oficial</td>
                  <td class="align-middle text-center text-justify">
                    La documentación es bastante extensa ya que abarca desde
                    las características del lenguaje hasta su propia sintaxis,
                    pero hay que decir a su favor que es muy completa. La
                    podemos encontrar en el siguiente enlace:
                    <a
                      href="https://kotlinlang.org/docs/kotlin-docs.pdf">https://kotlinlang.org/docs/kotlin-docs.pdf</a>.
                  </td>
                  <td class="align-middle text-center text-justify">
                    La documentación técnica de scala es extensa. De este
                    modo, en su página oficial de puede buscar la información
                    que se quiera encontrar desde el siguiente buscador:
                    <a
                      href="https://www.scala-lang.org/api/current/?_ga=1.241039811.1310790544.1468501313">https://www.scala-lang.org/api/current/?_ga=1.241039811.1310790544.1468501313</a>.
                  </td>
                  <td class="align-middle text-center text-justify">N/A</td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio A6: Competitividad</td>
                  <td class="align-middle text-center text-justify">30</td>
                  <td class="align-middle text-center text-justify">28</td>
                  <td class="align-middle text-center text-justify">
                    Se considera que debido al aumento de la necesidad de
                    análisis y aplicaciones de IA, Scala está subiendo
                    posiciones, poniéndose delante de Kotlin este año.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio A7: Influencia</td>
                  <td class="align-middle text-center text-justify">
                    Los lenguajes de programación por los que ha sido
                    influenciado Kotlin son C#, Eiffel, Gosu, Groovy, Java,
                    ML, Python, Scala y Swift
                  </td>
                  <td class="align-middle text-center text-justify">
                    Los principales lenguajes de programación por los que
                    Scala ha sido influenciado son: C++, C#, Java
                  </td>
                  <td class="align-middle text-center text-justify">
                    Debido a que Scala es influenciado por lenguajes como C# y
                    C++ tanto en su funcionamiento interno como sintaxis, la
                    curva de aprendizaje mencionada en el criterio B5 es
                    mayor.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio B1: Extensión del código</td>
                  <td class="align-middle text-center text-justify">2</td>
                  <td class="align-middle text-center text-justify">2</td>
                  <td class="align-middle text-center text-justify">
                    Al ser ambos lenguajes influenciados por Java, las líneas
                    de código en un programa pequeño como el ejemplo que se
                    usa en este documento son prácticamente las mismas. Ahora,
                    al ser Scala un lenguaje híbrido con programación
                    Funcional, hay implementaciones que supondrán menos líneas
                    que con programación Orientada a Objetos.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio B2: Tiempo de ejecución</td>
                  <td class="align-middle text-center text-justify">160</td>
                  <td class="align-middle text-center text-justify">620</td>
                  <td class="align-middle text-center text-justify">
                    La razón por la que tarda más Scala que Kotlin en ejecutar
                    un mismo programa es que Scala tiene un tiempo de
                    compilación mayor y un proceso más complejo, lo que hace
                    que al compilar y ejecutar sea mayor. JVM ejecuta sobre el
                    bytecode generado del código fuente, lo que al final hace
                    que el tiempo de ejecución sea más o menos el mismo, la
                    diferencia está en el tiempo de compilación, el cual es
                    mayor en Scala.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio B3: Versión JVM</td>
                  <td class="align-middle text-center text-justify">8-13</td>
                  <td class="align-middle text-center text-justify">6-14</td>
                  <td class="align-middle text-center text-justify">N/A</td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio B4: Nivel de estrés</td>
                  <td class="align-middle text-center text-justify">
                    El nivel de estrés no es muy alto, a no ser que se
                    realicen programas, los cuales requieran un uso muy
                    elevado de memoria, lo que implica un nivel alto de carga
                    de trabajo.
                  </td>
                  <td class="align-middle text-center text-justify">
                    El nivel de estrés en Scala no es muy alto a no ser que se
                    realicen algunas operaciones al realizar programas que
                    requieran un gran uso de memoria.
                  </td>
                  <td class="align-middle text-center text-justify">
                    Al final, el nivel de estrés al que se someta el sistema
                    (incluyendo hardware) dependerá de los recursos de los que
                    requiera el programa y la carga a la que lo someta.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio B5: Curva de aprendizaje</td>
                  <td class="align-middle text-center text-justify">30</td>
                  <td class="align-middle text-center text-justify">65</td>
                  <td class="align-middle text-center text-justify">
                    La curva aumenta destacablemente en Scala, debido a que el
                    aprendizaje y uso del mismo requiere el conocimiento de
                    dos paradigmas, por lo que requiere más tiempo partiendo
                    de un nivel de conocimiento de haber trabajado solo con el
                    paradigma Orientado a Objetos.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio C1: Tiempo de vida</td>
                  <td class="align-middle text-center text-justify">
                    Kotlin lleva desarrollándose desde 2011; es decir 9 años.
                  </td>
                  <td class="align-middle text-center text-justify">
                    Scala se desarrolló en el año 2001, por lo que el tiempo
                    de vida de este lenguaje es de 19 años
                  </td>
                  <td class="align-middle text-center text-justify">
                    La razón por la que ha avanzado muy rápido Kotlin es por
                    el hecho de tener un proyecto desarrollándose en
                    JetBrains, además de ser desde hace varios años el lenguaje de primer nivel de Android,
                    que es el sistema operativo móvil más utilizado del mundo.
                    <br>
                    Scala empezó a desarrollarse por una persona
                    la cual poco a poco fue introduciendo un equipo.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio C2: Control de errores</td>
                  <td class="align-middle text-center text-justify">
                    En Kotlin a diferencia de otros lenguajes, Kotlin no tiene
                    excepciones previamente definidas como puede ser en Java.
                  </td>
                  <td class="align-middle text-center text-justify">
                    En Scala, las excepciones son definidas en el código.
                  </td>
                  <td class="align-middle text-center text-justify">N/A</td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio C3: Test de caja negra</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">
                    Puede aplicarse en ambos, siempre y cuando se introduzcan
                    datos de entradas y genera una salida el bloque que se
                    esté probando
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio C4: Test de caja blanca</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">
                    Es necesaria una implementación para el funcionamiento de
                    un programa, por lo que el estudio de la estructura es
                    posible y necesario.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio D1: Soporte técnico</td>
                  <td class="align-middle text-center text-justify">
                    Kotlin dispone de una web con soporte técnico en la cual
                    puedes consultar cualquier cosa acerca con un experto en
                    dicho lenguaje. Su link es el siguiente:
                    <a
                      href="https://www.kotlindevelopment.com/kotlin-support/">https://www.kotlindevelopment.com/kotlin-support/</a>
                    .
                  </td>
                  <td class="align-middle text-center text-justify">
                    Scala dispone de un soporte técnico en español para países
                    de Latinoamérica y España. El enlace es la siguiente:
                    <a href="https://scala.com/es/support-technical/">https://scala.com/es/support-technical/</a>.
                  </td>
                  <td class="align-middle text-center text-justify">N/A</td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio D2: FAQ</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">
                    FAQ de Scala se centra más en la estructura y sintaxis del
                    propio lenguaje, debido a que su sistema híbrido le
                    proporciona un valor añadido en comparación a otros
                    lenguajes, como Kotlin, el cual se basa únicamente en
                    objetos y sus relaciones.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio D3: Soporte y mantenimiento</td>
                  <td class="align-middle text-center text-justify">
                    Kotlin dispone de soporte y mantenimiento cada cierto
                    tiempo, el cual es llevado a cabo por sus desarrolladores
                  </td>
                  <td class="align-middle text-center text-justify">
                    Scala dispone de soporte y mantenimiento sin coste
                    adicional para todos los Asociados Certificados de Scala y
                    para los clientes de Scala. El enlace es el siguiente:
                    <a href="https://scala.com/es/support-technical/">https://scala.com/es/support-technical/</a>.
                  </td>
                  <td class="align-middle text-center text-justify">N/A</td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">Criterio D4: Demostraciones</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">SI</td>
                  <td class="align-middle text-center text-justify">N/A</td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
    <br>
    <br>
  </div>
  <div class="container-fluid even-container">

    <div class="row justify-content-center">
      <div class="col-sm-12 text-center">
        <h1 id="6" class="section-title">6. Recomendaciones</h1>
      </div>
    </div>
    <br />
    <div class="row justify-content-center">
      <div class="col-sm-12 justify-content-center">
        <div class="row justify-content-center">
          <h2>6.1 Situación Kotlin</h2>
        </div>
        <br>
        <div class="row justify-content-center">
          <h3>6.1.1 Descripción de la situación</h3>
        </div>
        <br>
        <div class="row justify-content-center">

          <div class="criterio col-sm-10">
            <p>
              B&B es una pequeña empresa de desarrollo de software que se dedica a
              desarrollar aplicaciones de diversa índole para sus empresas. Esta
              empresa ha programado hasta ahora en Java y Python. Sin embargo, un
              cliente les ha solicitado hacer una aplicación que le permite llevar
              un seguimiento de sus propios clientes, incluyendo compras
              realizadas, datos personales, estadísticas de compra, etc, buscando
              cierta extensibilidad para poder llevar esa administración en
              distintos dispositivos, teniendo en cuenta que los usuarios que
              utilizarán la aplicación son además usuarios de dispositivos con
              Android instalado.
              <br />
              <br />
              A pesar de contar con equipos de desarrollo pequeños, no tener un
              número excesivo de empleados y no haber trabajado hasta ahora con
              otro lenguaje, quieren utilizar una nueva tecnología ya que así B&B
              se desenvuelve en una nueva tendencia, pero aplicando también
              conocimientos previos.
            </p>
          </div>
        </div>

        <br>
        <div class="row justify-content-center">
          <h3>6.1.2 Recomendacion de la tecnología a utilizar</h3>
        </div>
        <br>
        <div class="row justify-content-center">

          <div class="criterio col-sm-10">
            <p>
              La recomendación de la tecnología a escoger es Kotlin. Esto se debe
              a que este lenguaje de programación ha sido diseñado con la función
              de hacer aplicaciones Android y a raíz de esto, dispone de mucha más
              extensibilidad que Scala. Además, la sintaxis de este lenguaje para
              crear estas aplicaciones para Android, es similar a Java, por lo que
              la empresa no tendrá problemas en familiarizarse con este lenguaje.
              Las ventajas principales que ofrecería a la empresa son:
              <ul>
                <li>Dispone de una comunidad principal en español.</li>
                <li>
                  Tiene una documentación muy práctica y bien explicada en inglés.
                </li>
                <li>
                  Dispone de un soporte y mantenimiento para aquellos que usen este
                  lenguaje.
                </li>
                <li>El tiempo de ejecución de las aplicaciones es muy rápido.</li>
              </ul>
            </p>
          </div>
          <div class="criterio col-sm-10">
            <table class="table table-striped">
              <thead>
                <tr>
                  <th class="align-middle text-center text-justify" scope="col">Criterios relevantes</th>
                  <th class="align-middle text-center text-justify" scope="col">Ventajas de Kotlin</th>
                  <th class="align-middle text-center text-justify" scope="col">Ventajas de Scala</th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <th class="align-middle text-center text-justify">A.4: Comunidad</th>
                  <td class="align-middle text-center text-justify">
                    Tiene una comunidad oficial en español lo cual aporta mucha
                    más fiabilidad a todo lo que se muestre acerca de Kotlin en
                    dicha comunidad.
                  </td>
                  <td class="align-middle text-center text-justify">
                    No tiene una comunidad oficial, pero dispone de muchos foros
                    en los cuales se puede encontrar bastante información.
                  </td>
                </tr>
                <tr>
                  <th class="align-middle text-center text-justify">A.5: Documentación técnica oficial</th>
                  <td class="align-middle text-center text-justify">
                    Muy extensa y muy completa. Además, tiene varios apartados en
                    los cuales nos habla de forma práctica de como usar Kotlin en
                    Android, algo fundamental para la situación en la que se
                    encuentra la empresa.
                  </td>
                  <td class="align-middle text-center text-justify">Es bastante extensa y está muy documentada</td>
                </tr>
                <tr>
                  <th class="align-middle text-center text-justify">B.2: Tiempo de ejecución</th>
                  <td class="align-middle text-center text-justify">
                    Kotlin tiene un tiempo de ejecución muy rápido tanto en la
                    propia consola como en las ventanas de las aplicaciones
                    Android creadas.
                  </td>
                  <td class="align-middle text-center text-justify">El tiempo de ejecución es bastante rápido.</td>
                </tr>
              </tbody>
              <tr>
                <th class="align-middle text-center text-justify">D.3: Soporte y mantenimiento</th>
                <td class="align-middle text-center text-justify">
                  Kotlin nos ofrece mantenimiento y soporte cada cierto tiempo
                  para todas aquellas personas que usen este lenguaje.
                </td>
                <td class="align-middle text-center text-justify">
                  Scala ofrece soporte y mantenimiento, pero con la condición de
                  ser usuario registrado en Scala.
                </td>
              </tr>
            </table>
          </div>
          <br>
          <br>
        </div>
        <div class="row justify-content-center">
          <h2>6.2 Situación Scala</h2>
        </div>
        <br>
        <br>
        <div class="row justify-content-center">
          <h3>6.2.1 Descripción de la situación</h3>
        </div>
        <div class="row justify-content-center">

          <div class="criterio col-sm-10">
            <p>
              Una empresa de desarrollo software, la cual es experta en la
              implantación de sistemas automáticos y herramientas de Big Data, ha
              sido contratada por una empresa de telefonía, la cual les ha
              ofrecido un proyecto para desarrollar un software que identifique
              qué clientes están en “peligro” de darse de baja de sus servicios
              para hacer acciones comerciales que eviten que se vayan a la
              competencia.
              <br />
              <br />
              La empresa de telefonía tiene en su poder una gran cantidad de datos
              de clientes los cuales utiliza meramente para las gestiones más
              básicas. La pequeña empresa cree que utilizar estos datos pueden
              predecir cuándo un cliente decidirá darse de baja y gestionar la
              mejor acción para evitarlo; es decir, esta información almacenada en
              una base de datos se puede explotar para predecir futuros
              comportamientos, favorecer aquellos que mejoran los objetivos de
              negocio y evitar aquellos que son perjudiciales.
              <br />
              <br />
              Para ello, la empresa debe de decidir qué opción escoger para el
              desarrollo del programa que sea capaz de administrar esa
              información, teniendo en cuenta que habrá que utilizar técnicas de
              aprendizaje automático.
            </p>
          </div>
        </div>

        <br>
        <div class="row justify-content-center">
          <h3>6.2.2 Recomendacion de la tecnología a utilizar</h3>
        </div>
        <br>
        <div class="row justify-content-center">

          <div class="criterio col-sm-10">
            <p>
              La mejor tecnología para alcanzar el objetivo en la situación
              descrita sería el lenguaje de programación Scala. Scala proporciona
              la posibilidad de hacer crecer un negocio o proyecto sin tener que
              volver a invertir en infraestructura. Además, se trata de un
              lenguaje funcional y orientado a objetos, así que la computación
              puede ser distribuida a través de los servidores de un Data Center.
              Esto hace que Scala sea una gran opción para las CPU con varios
              núcleos y para cargas de trabajo distribuidas por Cloud Computing lo
              cual es indispensable para escenarios de análisis de Big Data.
              <br />
              <br />
              También, los desarrolladores de la empresa proveedora son expertos
              en Haskell y lenguajes sobre JVM como pueden ser Kotlin y Groovy,
              por lo que no supone un problema mayor el aprender un lenguaje
              híbrido y combinar conocimientos, siendo es una ventaja mayor el
              hecho de que ya sepan cómo funciona JVM.
              <br />
              <br />
              Como conclusión, Scala es la mejor opción, debido a su
              comportamiento en ambos paradigmas, su versatilidad en el análisis y
              desarrollo en machine learning, y su velocidad de ejecución (que no
              de compilación), hacen que este lenguaje sea la opción ideal para la
              empresa.
            </p>
          </div>
          <div class="criterio col-sm-10">
            <table class="table table-striped">
              <thead>
                <tr>
                  <th class="align-middle text-center text-justify" scope="col">Criterios relevantes</th>
                  <th class="align-middle text-center text-justify" scope="col">Ventajas de Scala</th>
                  <th class="align-middle text-center text-justify" scope="col">Ventajas de Kotlin</th>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td class="align-middle text-center text-justify">B.4: Nivel de estrés</td>
                  <td class="align-middle text-center text-justify">
                    El nivel de estrés no es muy alto, a no ser que se realicen
                    programas, los cuales requieran un uso muy elevado de memoria,
                    lo que implica un nivel alto de carga de trabajo.
                  </td>
                  <td class="align-middle text-center text-justify">
                    Al ser un lenguaje de programación, el nivel de estrés no es
                    muy alto, a no ser que se realicen programas, los cuales
                    requieran un uso muy elevado de memoria, lo que implica una
                    alta carga de trabajo.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">B.5: Curva de aprendizaje</td>
                  <td class="align-middle text-center text-justify">
                    La curva de aprendizaje depende del nivel del usuario. Las
                    horas anteriormente escritas en este criterio se refieren a
                    las horas de introducción que un programador principiante
                    necesita para manejar de forma suficiente Scala.
                  </td>
                  <td class="align-middle text-center text-justify">
                    Kotlin al ser un lenguaje bastante parecido a Java en cuando a
                    sintaxis, se aprende bastante rápido.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">C.2: Control de errores</td>
                  <td class="align-middle text-center text-justify">En Scala, las excepciones son definidas en el
                    código.</td>
                  <td class="align-middle text-center text-justify">
                    En Kotlin a diferencia de otros lenguajes, Kotlin no tiene
                    excepciones previamente definidas como puede ser en Java.
                  </td>
                </tr>
                <tr>
                  <td class="align-middle text-center text-justify">D.1: Soporte técnico</td>
                  <td class="align-middle text-center text-justify">
                    Scala dispone de un soporte técnico en español para países de
                    Latinoamérica y España.
                  </td>
                  <td class="align-middle text-center text-justify">
                    Kotlin dispone de una web con soporte técnico en la cual
                    puedes consultar cualquier cosa acerca con un experto en dicho
                    lenguaje.
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>

</html>